# coding=utf-8

#~ from tut_data import *
from analyse_user_input import *
from utils import _

            
import re
re_space = re.compile(r'[\t \s]+')

class Interaction():
    def __init__(self, text):
        self.text = text
        self.lines = [l.strip() for l in text.split('\n')]
        self.lineno = -1
        self.target_lineno = 0
        self.headers_lineno = []

        
    def interface_action(self, cmd):
        cmd_parts = re_space.split(cmd)
        action, args = cmd_parts[0].strip(), cmd_parts[1:]

        if action == 'lineno':
            print _("lineno: %s") % self.lineno

        if action in ['next', 'n'] :
            try:
                shift = int(args[0])
                print _("going to line no. %s") % self.target_lineno
            except (IndexError, ValueError):
                shift = 1
            self.target_lineno = self.lineno + shift
            
        
        if action == 'goto':
            try:
                self.target_lineno = int(args[0])
                print _("going to line no. %s") % self.target_lineno
            except (IndexError, ValueError):
                print _("wrong command arguments")
                
            
        elif action in ['menu', 'm']:
            self.get_topics()
            print
            
            try:
                input_choose = int(raw_input(_("Choose the topic (enter number): ")))
                if input_choose:
                    self.target_lineno = self.headers_lineno[input_choose-1]
                    print _("going to topic no. %s (lien no.: %s)") % (input_choose, self.target_lineno)
                #~ print self.headers_lineno
            except (IndexError, ValueError):
                print _("wrong input arguments")
            #~ except IndexError:
                #~ pass
     
        elif action in ['restart', 'r']:
            for i in range(10): print
            print _("    *** RESTARTING ***   ")
            tutorial_vars = {}
            self.__init__(self.text)


    def chat(self, tag, line = ''):
        if tag == 'mistake':
            #~ print
            print _("Please correct your mistake:") # by retyping
            print line

    def get_topics(self):
        self.headers_lineno = []
        for i, line in enumerate(self.lines):
            line = line.strip()
            if line.startswith('=') and line.endswith('='):
                self.headers_lineno.append(i)

        print _("  Topics:")
        print
        print 0, _(" Leave here")
        for menu_nr, line_nr in enumerate(self.headers_lineno):
            print menu_nr+1, self.lines[line_nr].replace('=', ' ') #replacement is risky -- now you can't use = inside of topic name
            #line_nr, 
                

    def main(self, text = ''):
        if text:
            __init__(text)
            #~ lines = self.text.split('\n')
            #~ lineno = -1
            #~ target_lineno = 0
        #for line in text.split('\n'):
        while self.lineno < len(self.lines)-1:
            goon = True
            self.lineno += 1
            self.line = self.lines[self.lineno].strip()    
            print self.line

            # this stuff is for execuding of expected input
            # but THIS CODE IS DUPLICATED also when raw_input getting
            if self.target_lineno and self.lineno < self.target_lineno:  
                if self.line.startswith('>>>') or self.line.startswith('???'):
                    expected_input = self.line[3:]
                    expected_input = expected_input.split('#')[0].strip(' \t')
                    expected_input += self.get_multiline_input()

                    given_result = self.look_for_given_result()
                    if input_type == '???':
                        try:
                            expected_input = str(eval(expected_input, tutorial_vars)) # which becomes expected output ;)
                        except (NameError, SyntaxError):
                            expected_input = given_result
                            
                    process_input(expected_input,  given_result )
                    print

                continue
            else:
                self.target_lineno = 0

                
            if self.line.startswith('>>>') or self.line.startswith('???'):
                expected_input = self.line[3:].strip(' \t')
                expected_input = expected_input.split('#')[0].strip(' \t')
                expected_input += self.get_multiline_input()
                input_type = self.line[:3]
                if input_type == '>>>': pass#print _("Retype the expression:")
                if input_type == '???' and not '#' in self.line : print _("Type in the RESULT of expression:")
                goon = False
                while goon == False:
                    input = raw_input('>>'+input_type[0]+' ')
                    #~ input = sys.stdin.readline()

                    
                    if input.startswith(':'):    # interface controll commands
                        goon = True
                        self.interface_action(input[1:])
                        self.lineno -= 1
                        continue

                    
                    given_result = self.look_for_given_result()
                    if input_type == '???':
                        try:
                            expected_input = str(eval(expected_input, tutorial_vars)) # which becomes expected output ;)
                        except (NameError, SyntaxError):
                            expected_input = given_result
                    
                    if not find_input_mistake(input, expected_input, tryinterpret=not given_result ):
                        process_input(expected_input, given_result)
                        print
                        # if there is relatively much text in next step,
                        # first let the learner see the result,
                        # and only then goon
                        for input_start in ('>>>', '???'):
                            if '\n'.join(self.lines[self.lineno +1:]).strip(' \n').find(input_start) > 80: 
                                raw_input(_("press Enter")) 
                                print
                                break                        
                        goon = True
                    else:
                        self.chat('mistake', self.line)
                        
    def get_multiline_input(self):
        multiline_input = ''
        tmp_exptected_input = self.lines[self.lineno][:3]
        shift_start = len(tmp_exptected_input) - len(tmp_exptected_input.lstrip());
        
        while len(self.lines) > self.lineno+1 \
        and self.lines[self.lineno+1].startswith('...'):
            self.lineno += 1
            #~ print self.lines[self.lineno]
            print self.lines[self.lineno][3 + shift_start:]
            multiline_input = '\n' + self.lines[self.lineno][3 + shift_start:]
        return multiline_input

    def look_for_given_result(self):
        given_result = ''
        if len(self.lines) > self.lineno+1:
            if self.lines[self.lineno+1].startswith('==>'):
                self.lineno += 1
                #~ print self.lines[self.lineno]
                given_result = self.lines[self.lineno][3:].strip()
        return given_result

                
